#include "syntax.h"

PQ* init_pq() {
  PQ* q    = malloc((sizeof(*q)));
  q->first = NULL;
  return q;
}
N* init_n(Vec3i data) {
  N* n    = malloc(sizeof(*n));
  n->d    = data;
  n->next = NULL;
  return n;
}
Vec3i pq_pop(PQ* q) {
  if(q->first == NULL) return vec3is(-1);
  Vec3i t = q->first->d;
  q->first = q->first->next;
  return t;
}
int pq_push(PQ* q, N* n) {
  if(q->first == NULL) {
    q->first = n;
  } else {
    N* temp = q->first;
    if(temp->d.x > n->d.x) {
      n->next = q->first;
      n->d.y  = q->first->d.x - 1;
      q->first = n;
    } else {
      while(temp->next != NULL && temp->next->d.x < n->d.x) {
        temp = temp->next;
      }
      if(temp->d.y > n->d.x) return -1;
      n->next = temp->next;
      temp->next = n;
    }
  }
  //pq_sz(q);
  return 0;
}

void pq_empty(PQ* q) {
  free(q->first);
  q->first = NULL;
  return;
}

#if DEBUG
int pq_sz(PQ* q) {
  if(q->first == NULL) return -1;
  N* t     = q->first;
  printf("{%i,  %i}->", t->d.x, t->d.y);
  uint cnt = 1;
  while(t->next != NULL) {
    cnt++;
    t = t->next;
    printf("{%i,  %i}->", t->d.x, t->d.y);
  }
  printf("\n");
  return cnt;
}
#endif
